//+---------------------------------------------------------------------+
//|                                                          F2a_AO.mq5 | 
//|                                               Copyright  2009, XXX | 
//|                                                                     | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2009, XXX"
#property link ""
//----   
#property version   "1.00"
#property description "     NavelEMA"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 2
//----     
#property indicator_plots   2
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_ARROW
//----        Tomato 
#property indicator_color1  clrTomato
//----    1  4
#property indicator_width1  4
//----    
#property indicator_label1  "F2a_AO Sell"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_ARROW
//----        DodgerBlue 
#property indicator_color2  clrDodgerBlue
//----    2  4
#property indicator_width2  4
//----    
#property indicator_label2 "F2a_AO Buy"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint  MA_Filtr=3;
input uint  MA_Fast=13;
input uint  MA_Slow=144;
//+----------------------------------------------+

//----   ,    
//      
double SellBuffer[];
double BuyBuffer[];
//----      
int min_rates_total;
//----   
int Count[];
double Value1[],Value2[];
//+------------------------------------------------------------------+
//   CMoving_Average                                   |
//+------------------------------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+   
void Recount_ArrayZeroPos(
                          int &CoArr[],//        
                          int Size
                          )
  {
//----
   int numb,Max1,Max2;
   static int count=1;

   Max2=Size;
   Max1=Max2-1;

   count--;
   if(count<0) count=Max1;

   for(int iii=0; iii<Max2; iii++)
     {
      numb=iii+count;
      if(numb>Max1) numb-=Max2;
      CoArr[iii]=numb;
     }
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----   
   int nshift=3;
   min_rates_total=int(MathMax(MathMax(MA_Filtr,MA_Fast),MA_Slow)+nshift+9);

//----       
   ArrayResize(Count,nshift);
   ArrayResize(Value1,nshift);
   ArrayResize(Value2,nshift);

   ArrayInitialize(Count,0);
   ArrayInitialize(Value1,0.0);
   ArrayInitialize(Value2,0.0);

//----      
   SetIndexBuffer(0,SellBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(0,PLOT_ARROW,234);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);

//----      
   SetIndexBuffer(1,BuyBuffer,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(1,PLOT_ARROW,233);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----         
   string short_name="F2a_AO";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//----   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<min_rates_total) return(RESET);

//----    
   int first,bar;
   static int startbar,trend;
   double series,fema,sema,current,prev;
//----    CMoving_Average   SmoothAlgorithms.mqh 
   static CMoving_Average EMA1,EMA2,EMA3;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=10; //      
      startbar=first;
      trend=0;
     }
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      series=(close[bar]*5+open[bar]*2+high[bar]+low[bar])/9;
      fema=EMA1.EMASeries(startbar,prev_calculated,rates_total,MA_Fast,series,bar,false);
      sema=EMA2.EMASeries(startbar,prev_calculated,rates_total,MA_Slow,series,bar,false);
      Value1[Count[0]]=fema-sema;
      Value2[Count[0]]=EMA3.EMASeries(startbar,prev_calculated,rates_total,MA_Filtr,series,bar,false);
      current=Value2[Count[0]];
      prev=Value2[Count[1]];

      double AvgRange=0.0;
      for(int count=bar; count>=bar-9; count--) AvgRange+=MathAbs(high[count]-low[count]);
      double Range=AvgRange/10;

      BuyBuffer[bar]=0.0;
      SellBuffer[bar]=0.0;

      if(trend<=0)
         if(Value1[Count[0]]>Value1[Count[1]] && current>=prev && Value1[Count[1]]<=Value1[Count[2]])
           {
            BuyBuffer[bar]=low[bar]-Range*0.5;
            if(bar<rates_total-1) trend=+1;
           }

      if(trend>=0)
         if(Value1[Count[0]]<Value1[Count[1]] && current<=prev && Value1[Count[1]]>=Value1[Count[2]])
           {
            SellBuffer[bar]=high[bar]+Range*0.5;
            if(bar<rates_total-1) trend=-1;
           }

      if(bar<rates_total-1) Recount_ArrayZeroPos(Count,3);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
